// today's fortune
function FortuneOfTheDay( fortuneclass, key, items, websites ) {
    this.fortuneclass = fortuneclass;
    this.key = key;
    var sites;
    if ( websites ) {
        sites = websites;
    } else {
        sites = tr( "source-" + fortuneclass, "msn,infoseek,yahoo,excite" ).split( "," );
        //sites = tr( "source-" + fortuneclass, "msn,yahoo,excite" ).split( "," );
    }
    //var sites = tr( "msn,infoseek,yahoo,excite" ).split( "," );

    this.results = new Array();
    for ( var i = 0; i < sites.length; i++ ) {
        this.results.push( new FortuneFromSite( sites[ i ], fortuneclass, key ) );
    }

    if ( items == undefined ) {
        debug( "UNDEFINED " );
        items = [ "general", "love", "money", "business"];
    }
    this.items       = items;
    //this.isLoading   = false;
    this.isLoaded    = false;
    this.totalScore  = 0.0;
    this.callBack    = null;

    this.load        = FortuneOfTheDay__load;
    this.isLoading   = FortuneOfTheDay__isLoading;
    this.getScores     = FortuneOfTheDay__getScores;
    this.getTotalScore = FortuneOfTheDay__getTotalScore;
    this.getMessages   = FortuneOfTheDay__getMessages;
}

FortuneOfTheDay.prototype.toString = function() {
    return this.fortuneclass + " " + this.key + "\n" + this.totalScore;
};

function FortuneOfTheDay__getScores( genre ) {
    var scores = new Array();
    for ( var i = 0; i < this.results.length; i++ ) {
        if ( this.results[ i ].hasScore( genre ) ) {
            scores.push( this.results[ i ].getScore( genre ) 
                         / this.results[ i ].maxScore );
        }
    }
    return scores;
}

function FortuneOfTheDay__getMessages( genre ) {
    var messages = new Array();
    for ( var i = 0; i < this.results.length; i++ ) {
        if ( this.results[ i ].hasScore( genre ) ) {
            messages.push( this.results[ i ].messages[ genre ] );
        }
    }
    return messages;
}

function FortuneOfTheDay__isLoading() {
    for ( var i = 0; i < this.results.length; i++ ) {
        if ( this.results[ i ].isLoading ) return true;
    }
    return false;
}

function FortuneOfTheDay__load( endHandler ) {
    //debug( "FortuneOfTheDay__load " + this.isLoaded );
    if ( this.isLoaded == false ) {
        //this.isLoaded  = false;
        //this.isLoading = true;
        //debug( "num of results : " + this.results.length );
        for ( var i = 0; i < this.results.length; i++ ) { 
            //debug( "FortuneOfTheDay__load, retrieving " + i  );
            this.results[ i ].retrieveData();
        }    
        //this.isLoading = false;
        this.isLoaded  = true;
    }
    if ( endHandler ) {
        setTimeout( endHandler, 1000 );
        //endHandler( this );
    }
}

function FortuneOfTheDay__getTotalScore() {
    if ( this.items.length == 0 ) return 0.0;
    var total = 0;
    for ( var i = 0; i < this.items.length; i++ ) {
        var scores = this.getScores( this.items[ i ] );
        for ( var j = 0; j < scores.length; j++ ) {
            total += scores[ j ];
        }
    }
    this.totalScore = total;
    return this.totalScore;
}

function FortuneOfTheDay__comparator( f1, f2 ) {
    var t1 = f1.getTotalScore();
    var t2 = f2.getTotalScore();
    if ( t1 > t2 ) return -1;
    if ( t1 < t2 ) return 1;
    return 0;
//    return ( f1.totalScore < f2.totalScore );
}
