var Fortune = null;
var popUpMessages = null;
var tableMode = false;
var isMoving = false;
var Resizer = null;

var FortuneDatabase = null;
var FortunesOfConstellation = new Array();
var CONSTELLATIONS = [ "aries", "taurus", "gemini", "cancer",
                       "leo", "virgo", "libra", "scorpio",
                       "sagittarius", "capricorn", "aquarius", 
                       "pisces"];
var BLOOD_TYPES = [ "A", "B", "AB", "O" ];
var KeyRepertorie = { "constellation":CONSTELLATIONS, 
                      "blood":BLOOD_TYPES 
};

var reloadMonitor = null;
var lastDate = null;

var GraphItems = new Array();

var GraphConfig = {
    barTop   : 0,
    barLeft  : 10,
    barWidth : 172,
    barHeight: 13,
    barStep  : 15,
    top      : 0,
    left     : 0,
    width    : 180,
    height   : 150,
    rowHeight: 15,
    starMax  : 5
    
};

var FortuneConfig = {
    items     : [ "general", "love", "money", "business" ],
    itemColors: [ "white", "red", "yellow", "blue" ],
    fortune   : "constellation",
    keys      : CONSTELLATIONS,
    key       : CONSTELLATIONS[ 0 ]
};

var BarImages = new Array();
function debug( message ) {
    if ( window.Logger ) {
        Logger.log( message );
        return;
    }
    var debugDiv = document.getElementById( "debugDiv" );
    if ( debugDiv ) {
        debugDiv.appendChild( document.createTextNode( message ) );
        debugDiv.appendChild( document.createElement( "br" ) );
    }
}
// retrieve data from localized string database
function tr( key, defaultValue ) {
    try {
        var cnv = localizedStrings[ key ];
      if ( cnv ) return cnv;
    } catch ( e ) {
    }
    if ( defaultValue ) return defaultValue;
    return key;
}


function monitorReload() {
    var date = new Date();
    var day = date.getMonth() + "/" + date.getDay();
    var hour = date.getHours();
    debug( "checking reloading : " + day + " " + lastDate  );
    if ( lastDate == null || ( lastDate != day && hour >= 9 ) ) {
        reloadFortunes();
    }
}

function getPreference( key, defval ) {
    try {
        if ( window.widget ) {
            var value = widget.preferenceForKey( key );
            if ( value ) {
                return value;
            }
        }
    } catch ( e ) {
    }
    return defval;
}

function setup() {
    // set fotune
    changeFortuneGenre( getPreference( "fortune", "constellation" ) );

    // set fortune items
    var canvas = document.getElementById( "graph" );


    if ( canvas ) {
        var ps = document.defaultView.getComputedStyle( canvas );
        var top    = _getElementPropertyRecursively( canvas, "top" );
        var left   = _getElementPropertyRecursively( canvas, "left" );
        var width  = parseInt( ps.getPropertyValue( "width" ) );
        var height = parseInt( ps.getPropertyValue( "height" ) );
        GraphConfig.left   = left;
        GraphConfig.top    = top;
        GraphConfig.width  = width;
        GraphConfig.height = height;
        drawGraph();

        // set genre notations
        var elem_parent = canvas.parentElement;
        for ( var i = 0; i < FortuneConfig.items.length; i++ ) {
            var elem = document.createElement( 'span' );
            elem.setAttribute( 'class', 'genreLabel' );
            //elem.style.left = ;
            elem.style.top  = ( GraphConfig.barStep * i ) + "px";
            elem.appendChild( document.createTextNode( tr( "fortune-" + FortuneConfig.items[ i ] ) ) );
            elem_parent.appendChild( elem );
        }

    }

    {
        var front = document.getElementById( "front" );
        var style = document.defaultView.getComputedStyle( front );
        var width = parseInt( style.getPropertyValue( "width" ) );
        var height = parseInt( style.getPropertyValue( "height" ) );

        var elem_message = document.getElementById( "message" );
        if ( elem_message ) {
            var offset = parseInt( document.defaultView.getComputedStyle( elem_message ).getPropertyValue( "height" ) );
            if ( isNaN( offset ) == false ) {
                height -= offset;
                //debug( "message " + offset  + " => " + height );
            }
        }

        Resizer = new Expander( front, width, height + FortuneConfig.keys.length * GraphConfig.rowHeight );
        Resizer.positionFixed = true;
        Resizer.maxSteps = 8;
    }

    debug( "load images" );
    preloadImages();

    //set monitor
    reloadMonitor = setInterval( monitorReload, 1000 * 300 );

    debug( "load data" );
    setTimeout( loadFortune, 0 );

    // css test
//     var elems = document.getElementsByTagName( "div" );
//     for ( var i = 0; i < elems.length; i++ ) {
//         var s = document.defaultView.getComputedStyle( elems[ i ] );
//         debug( i + " : " + elems[ i ].getAttribute( "id" ) + " : " + s.getPropertyValue( "font-size" ) );
//     }
//     var e2 = document.getElementById( "message" );
//     var s2 = document.defaultView.getComputedStyle( e2 );
//     debug( s2 );
//     debug( "font size of message : " + s2.getPropertyValue( "font-size" ) );
//     debug( "font of message      : " + e2.style.fontSize );//s2.getPropertyValue( "font" ) );

//     var e1 = document.getElementById( "debugDiv" );
//     var s1 = document.defaultView.getComputedStyle( e1 );
//     debug( s1 );
//     debug( "font size of debugDiv : " + s1.getPropertyValue( "font-size" ) );
//     debug( "font of debugDiv      : " + s1.getPropertyValue( "font" ) );

//    debug( "setup finished" );
}


// buttton event handlers

// mode switch
function switchButtonDown( event ) {
    var src = document.getElementById( "switchArrow" );
    if ( !tableMode ) {
        src.style.backgroundImage = "url(Images/ButtonLowerDark.png)";
    } else {
        src.style.backgroundImage = "url(Images/ButtonUpperDark.png)";
    }
    src.addEventListener( "mouseup", switchButtonUp, true ); 
    src.addEventListener( "mouseout", switchButtonOut, true ); 
}

function switchButtonUp( event ) {
    switchButtonOut( event );
    if ( toggleMode( event ) ) {
        var src = document.getElementById( "switchArrow" );
        if ( !tableMode ) {
            src.style.backgroundImage = "url(Images/ButtonUpper.png)";
        } else {
            src.style.backgroundImage = "url(Images/ButtonLower.png)";
        }
    }
}
function switchButtonOut( event ) {
    var src = document.getElementById( "switchArrow" );
    if ( !tableMode ) {
        src.style.backgroundImage = "url(Images/ButtonLower.png)";
    } else {
        src.style.backgroundImage = "url(Images/ButtonUpper.png)";
    }
    src.removeEventListener( "mouseup", switchButtonUp, true ); 
    src.removeEventListener( "mouseout", switchButtonOut, true ); 
}

// reload
function reloadButtonDown( event ) {
    var src = document.getElementById( "reloadButton" );
    src.style.backgroundImage = "url(Images/ButtonReloadDark.png)";
    src.addEventListener( "mouseup", reloadButtonUp, true );
    src.addEventListener( "mouseout", reloadButtonOut, true );
}

function reloadButtonUp( event ) {
    reloadButtonOut( event );
    reloadFortunes();
}

function reloadButtonOut( event ) {
    var src = document.getElementById( "reloadButton" );
    src.style.backgroundImage = "url(Images/ButtonReload.png)";
    src.removeEventListener( "mouseup", reloadButtonUp, true );
    src.removeEventListener( "mouseout", reloadButtonOut, true );
}

// !reloadFortunes
function reloadFortunes() {
    debug( "reloading" );

    // set loaded date
    var date = new Date();
    var day = date.getMonth() + "/" + date.getDay();
    lastDate = day;

    try {
        changeFortuneGenre( FortuneConfig.fortune );
    } catch ( e ) {
        debug( e );
    }
//     for ( var i = 0; i < FortuneDatabase.length; i++ ) {
//         FortuneDatabase[ i ].isLoaded = false;
//     }
//    debug( "loding" );
    try {
        setTimeout( loadFortune, 0 );
    } catch ( e ) {
        debug( e );
    }
}

function preloadImages() {
    var parts = [ "BarBottom", "BarBody", "BarTop" ];
    var colors = [ "Red", "Blue", "Green", "Yellow", "Gray" ];
    for ( var i = 0; i < parts.length; i++ ) {
        for ( var j = 0; j < colors.length; j++ ) {
            var filename = parts[ i ] + colors[ j ];
            var im = new Image();
            im.src = "Images/" + filename + ".png";
            BarImages[ filename ] = im;
            //debug( filename );
        }
    }

    for ( var i = 0; i < 12; i++ ) {
        var im = new Image();
        im.src = "Images/wait" + i + ".png";
    }

    var sources = [ "ButtonReload", "ButtonLower", "ButtonUpper", 
                    "PointMoney", "PointBusiness", "PointLove", "PointGeneral" ];
    for ( var i = 0; i < sources.length; i++ ) {
        (new Image()).src = "Images/" + sources[ i ] + ".png";
        (new Image()).src = "Images/" + sources[ i ] + "Dark.png";
    }
}

// change genre of fortune
function changeFortuneGenre( genre ) {
    try {
        Fortune = null;
        FortuneConfig.fortune = genre;
        FortuneConfig.keys    = KeyRepertorie[ FortuneConfig.fortune ];
        FortuneConfig.key     = getPreference( "key", FortuneConfig.keys[ 0 ] );
        FortuneDatabase = new Array();

        for ( var i = 0; i < FortuneConfig.keys.length; i++ ) {
            FortuneDatabase.push( new FortuneOfTheDay( FortuneConfig.fortune, FortuneConfig.keys[ i ], FortuneConfig.items ) );
            if ( FortuneConfig.keys[ i ] == FortuneConfig.key ) {
                Fortune = FortuneDatabase[ i ];
            }
        }
        
        if ( Fortune == null ) {
            Fortune = FortuneDatabase[ 0 ];
            FortuneConfig.key = FortuneConfig.keys[ 0 ];
        }

    } catch ( e ) {
        debug( e );
    }

    if ( Resizer ) {
        if ( Resizer.isMoving == false ) {
            try {
                Resizer.size2.height = Resizer.size1.height + FortuneConfig.keys.length * GraphConfig.rowHeight;
                var elem_message = document.getElementById( "message" );
                if ( elem_message ) {
                    var offset = parseInt( document.defaultView.getComputedStyle( elem_message ).getPropertyValue( "height" ) );
                    if ( isNaN( offset ) == false ) {
                        Resizer.size2.height -= offset;
                    }
                }
            } catch ( e ) {
                debug( e );
            }
        }
        //Resizer = new Expander( front, width, height + FortuneConfig.keys.length * GraphConfig.rowHeight );
    }

    setSelection();

//     showIcon();
//    debug( Fortune );
}

// !setSelection
// set options of item selection
function setSelection() {
    // set selection

    var select = document.getElementById( "keySelection" );
    var children = select.childNodes;
    try {
        for ( var i = children.length - 1; i >= 0; i-- ) {
            select.removeChild( children.item( i ) );
        }
    } catch ( e ) {
        debug( e );
    }
    for ( var i = 0; i < FortuneConfig.keys.length ; i++ ) {
        try {
            var name = tr( "exp-" + FortuneConfig.keys[ i ] ).split( "," )[ 0 ];
            var option = document.createElement( "option" );
            option.setAttribute( "value", FortuneConfig.keys[ i ] );
            if ( FortuneConfig.key == FortuneConfig.keys[ i ] ) {
                option.setAttribute( "selected" );
            }
            option.appendChild( document.createTextNode( name ) );
            select.appendChild( option );
        } catch ( e ) {
            debug( e );
        }
    }

}

// !showIcon
// icon
function showIcon() {
    var img_icon = document.getElementById( "keyIcon" );
    var key = FortuneConfig.key;
    //debug( img_icon );
    if ( img_icon ) {
        var src = "Images/Icon" + key.substring( 0, 1 ).toUpperCase() 
            + key.substring( 1, key.length ) + ".png";
        //debug( src );
        img_icon.src = src;
    }

    // show icon
    var elem_exp = document.getElementById( "iconName" );
    if ( elem_exp ) {
        var texts = tr( "exp-" + FortuneConfig.key ).split( "," );
        var children = elem_exp.childNodes;
        for ( var i = children.length - 1; i >= 0; i-- ) {
            elem_exp.removeChild( children.item( i ) );
        }
        for ( var i = 0; i < texts.length; i++ ) {// - 1; i >= 0; i-- ) {
            elem_exp.appendChild( document.createTextNode( texts[ i ] ) );
            elem_exp.appendChild( document.createElement( "br" ) );
        }
    }
}

var pollingTimer = null;

// !loadFortunes
function loadFortune() {
    debug( "remove current threads" );
    FortuneFromSite__removeAllThreads();
    debug( "loading" );
    _startWaitTimer();
    if ( Fortune ) {
        Fortune.load( _handleFirstFortune );//loadNextFortune );
    }
}

function _handleFirstFortune() {
    repaint();

    debug( "first fortune loaded" );
    if ( pollingTimer ) {
        clearInterval( pollingTimer );
        pollingTimer = null;
    }

    pollingTimer = setInterval( _pollLoading, 100 );
    
    setTimeout( loadNextFortune, 10 );
}

function _pollLoading() {
    debug( "polling..." );
    var flag_loaded_all = true;
//     for ( var i = FortuneDatabase.length - 1; i >= 0; i-- ) {
    for ( var i = 0; i < FortuneDatabase.length; i++ ) {
        if ( FortuneDatabase[ i ].isLoaded ) continue;
        if ( FortuneDatabase[ i ].isLoading ) return;
        debug( "loading " + i );
        flag_loaded_all = false;
        FortuneDatabase[ i ].load();
        break;
    }
    if ( flag_loaded_all ) {
        clearInterval( pollingTimer );
        pollingTimer = null;
        repaint();
    }
}

function loadNextFortune() {
    //repaint();
    var callback = loadNextFortune;
    var lastindex = FortuneDatabase.length - 1
    for ( var i = FortuneDatabase.length - 1; i >= 0; i-- ) {
        if ( FortuneDatabase[ i ].isLoaded == false ) {
            var lastindex = i;
            break;
        }
    }
    for ( var i = 0; i < FortuneDatabase.length; i++ ) {
        var fortune = FortuneDatabase[ i ];
        if ( fortune.isLoaded == false ) {
            if ( i == lastindex ) {
                callback = loadEndHandler;
            }
            fortune.load( callback );
        }
        //FortuneDatabase[ i ].load();
    }
    //repaint();
}

function loadEndHandler() {
    repaint();
}

// repaint
function repaint() {
    //setSelection();
    showIcon();
    drawGraph();

    for ( var i = 0; i < FortuneDatabase.length; i++ ) {
        if ( FortuneDatabase[ i ].isLoading() ) {
            if ( tableMode ) {
                _showTable();
            }
            return;
        }
    }
    _stopWaitTimer();

}

// !drawGraph
//
function drawGraph( fortune ) {
    var canvas = document.getElementById( "graph" );
    if ( canvas == null ) return;
    if ( fortune == undefined ) {
        fortune = Fortune;
    }

    var cxt = canvas.getContext( "2d" );
    cxt.save();

    cxt.clearRect( 0, 0, GraphConfig.width, GraphConfig.height );

    var items = FortuneConfig.items;

    popupMessages = new Array();

    for ( var i = 0; i < items.length; i++ ) { // />
        var y = i * GraphConfig.barStep + GraphConfig.barTop;
        var h = GraphConfig.barHeight;
        //cxt.fillStyle = GraphConfig.colors[ i ];
        //cxt.strokeStyle = "black";
        //cxt.lineWidth = 1.0;

        var scores = fortune.getScores( items[ i ] );
        var messages = fortune.getMessages( items[ i ] );
        //debug( items[ i ] + ", " + scores.length );
        var xunit = GraphConfig.barWidth / scores.length;
        var x = GraphConfig.barLeft;
        var colors = [ "Blue", "Red", "Green", "Yellow", "Gray" ];
        for ( var j = 0; j < scores.length; j++ ) { //>
            var w = xunit * scores[ j ];

            //cxt.fillStyle = GraphConfig.colors[ j ];
            var color = colors[ j % colors.length ];
            {
//                 cxt.save();
//                 cxt.shadowColor   = "rgba(0,0,0,0.25)";
//                 cxt.shadowBlur    = "1";
//                 cxt.shadowOffsetX = "1";
//                 cxt.shadowOffsetY = "2";

                cxt.drawImage( BarImages[ "BarBody" + color ], x + 2, y, w - 2, h );
//                cxt.restore();
            }
            cxt.drawImage( BarImages[ "BarBottom" + color ], x, y, 3, h  );
            cxt.drawImage( BarImages[ "BarTop" + color ], x + w, y, 4, h  );
            //cxt.rect( x, y, w, h );
            //cxt.fill();
            if ( messages[ j ] ) {
                popupMessages.push( { left:x, top:y, right:x+w, bottom:y+h, message :messages[ j ] }  );
            } else {
                popupMessages.push( { left:x, top:y, right:x+w, bottom:y+h, message :"" }  );
            }
            x += w;
        }

    }
	
    cxt.restore();
} 


function showMessage( event ) {
    var x = event.x - GraphConfig.left;
    var y = event.y - GraphConfig.top;
    //debug( event.x + ", " + event.y + " => " + x + ", " + y );
    if ( popupMessages ) {
        for ( var i = 0; i < popupMessages.length; i++ ) {
            var m = popupMessages[ i ];
            //debug( "( " + m.left + ", " + m.top + ", " + m.right + ", " + m.bottom );
            if ( m.left <= x && x < m.right && m.top <= y && y < m.bottom ) {
                var mdiv = document.getElementById( "message" );
                if ( mdiv ) {
                    mdiv.innerText = m.message;
                }
                break;
            }
        }
    }
}

// change mode
// tableMode : table
//             message
function toggleMode( event ) {
    debug( "toggle : " + tableMode );
    if ( tableMode ) {
        if ( Resizer ) {
            if ( Resizer.isMoving == false ) {
                var table = document.getElementById( "rankTable" );
                table.style.display = "none";
                Resizer.callBack = _hideTable;
                Resizer.collapse();
            } else {
                return false;
            }
        } else {
            _hideTable();
        }
    } else {
        if ( Resizer ) {
            if ( Resizer.isMoving == false ) {
                Resizer.callBack = _showTable;
                Resizer.expand();
            } else {
                return false;
            }
        } else {
            _showTable();
        }
    }
    return true;
}


// !createTable
// remove current ranking and create a new rank table
//
function createTable( elem_table ) {
    var children = elem_table.childNodes;
    //debug( "current children size : " + children.length );
    for ( var i = children.length - 1; i >= 0; i-- ) {
        elem_table.removeChild( children.item( i ) );
    }
    var fortunes = new Array();
    for ( var i = 0; i < FortuneDatabase.length; i++ ) {
        if ( FortuneDatabase[ i ].isLoaded ) {
            fortunes.push( FortuneDatabase[ i ] );
        }
    }
    fortunes.sort( FortuneOfTheDay__comparator );
    
    var table = document.createElement( "div" );
    elem_table.appendChild( table );
    //debug( "table rows : " +  fortunes.length + " , " + table.childNodes.length );
    for ( var i = 0; i < fortunes.length; i++ ) {
        //debug( "SCORE : " + fortunes[ i ].totalScore );

        var row = document.createElement( "div" );
        row.setAttribute( "class", "rankRow" );
        table.appendChild( row );

        // rank
        var item1 = document.createElement( "span" );
        item1.setAttribute( "class", "rankItem" );
        item1.appendChild( document.createTextNode( '' + ( i + 1 ) ) );
        row.appendChild( item1 );

        // icon
        var item2 = document.createElement( "span" );
        var key = fortunes[ i ].key;
        item2.setAttribute( "value", key );
        item2.setAttribute( "onclick", "changeKey(event);" );
        item2.setAttribute( "class", "rankIcon" );
        var name = tr( key ).split( "," )[ 0 ];
        item2.appendChild( document.createTextNode( name ) );
        row.appendChild( item2 );

        // score
        var item3 = document.createElement( "span" );
        item3.setAttribute( "class", "rankDescription" );
        for ( var j = 0; j < FortuneConfig.items.length; j++ ) {
            var item = FortuneConfig.items[ j ];
            //var color = FortuneConfig.itemColors[ j ];
            var itemU = item.substring( 0, 1 ).toUpperCase() + item.substring( 1, item.length );
            var scores = fortunes[ i ].getScores( item );
            var sum = 0;
            for ( var k = 0; k < scores.length; k++ ) {
                sum += scores[ k ];
            }
            var num = parseInt( sum * GraphConfig.starMax / scores.length + .5 );
            //debug( "score " + item + " : " + num + " / " + GraphConfig.starMax );
            //var text_colored = document.createElement( "span" );
            //text_colored.style.color = color;
            for ( var k = 0; k < num; k++ ) {
                var img = document.createElement( "img" );
                img.src = "Images/Point" + itemU + ".png";
                img.setAttribute( "class", "point" );
                item3.appendChild( img );
                //text_colored.appendChild( document.createTextNode( "★" ) );
            }
            //item3.appendChild( text_colored );
            //var text_missed = document.createElement( "span" );
            //text_missed.style.color = "gray";
            for ( var k = num; k < GraphConfig.starMax; k++ ) {
                var img = document.createElement( "img" );
                img.src = "Images/Point" + itemU + "Dark.png";
                img.setAttribute( "class", "point" );
                item3.appendChild( img );
                //text_missed.appendChild( document.createTextNode( "★" ) );                
            }
            //item3.appendChild( text_missed );
            item3.appendChild( document.createTextNode( " " ) );
            
        }
        
        //item3.appendChild( document.createTextNode( fortunes[ i ].totalScore ) );
        row.appendChild( item3 );
    }
}

function _showTable() {
    if ( isMoving ) return;
    var elem = document.getElementById( "message" );
    if ( elem ) {
        elem.style.display = "none";
    }

    var elem_table = document.getElementById( "rankTable" );
    if ( elem_table ) {
        createTable( elem_table );
        elem_table.style.display = "block";
    } else {
        debug( "no table" );
    }
    tableMode = true;
}

function _hideTable() {
    if ( isMoving ) return;
    var elem_table = document.getElementById( "rankTable" );
    if ( elem_table ) {
        elem_table.style.display = "none";
    }

    var elem = document.getElementById( "message" );
    if ( elem ) {
        elem.style.display = "block";
    }
    tableMode = false;
}

function changeKey( event ) {
    var src = event.srcElement;
    if ( src.nodeType == 3 ) {
        src = src.parentElement;
    }
    var value = src.value;
    if ( value == null || value == undefined ) {
        debug( "event from element without 'value'" );
        return;
    }
    debug( value );

    if ( value != FortuneConfig.key ) {
        // change preference
        if ( window.widget ) {
            debug( "change preference" );
            widget.setPreferenceForKey( value, "key" );
        }
 
       debug( "change from " + FortuneConfig.key );
        for ( var i = 0; i < FortuneConfig.keys.length; i++ ) {
            if ( value == FortuneConfig.keys[ i ] ) {
                FortuneConfig.key = value;
                Fortune = FortuneDatabase[ i ];
                if ( Fortune.isLoaded ) {
                    repaint();
                } else {
                    Fortune.load( repaint );
                }
            }
        }

        var mdiv = document.getElementById( "message" );
        mdiv.innerText = "";

    }
}

// determine position recursively
// all containers has CSS property 'position:absolute'
function _getElementPropertyRecursively( elem, key ) {
    var style = document.defaultView.getComputedStyle( elem );
    if ( style == null || style == undefined ) return 0;
    var property = style.getPropertyValue( key );
    if ( property == undefined || property == null ) {
        return 0;
    }
    var value = parseInt( property );
    if ( isNaN( value ) ) value = 0;
    var parent = elem.parentElement;
    if ( parent ) {
        value += _getElementPropertyRecursively( parent, key );
    }
    return value;
}


var waitTimer = null;
var waitCounter = 0;

function _startWaitTimer() {
    debug( "Start wait timer " );
    _stopWaitTimer();
    var elem = document.getElementById( "wait" );
    elem.style.display = "block";
    _tickWaitTimer();
    waitTimer = setInterval( _tickWaitTimer, 66 );
}

function _tickWaitTimer() {
    waitCounter = ( waitCounter + 1 ) % 12;
    var elem = document.getElementById( "wait" );
    elem.src = "Images/wait" + waitCounter + ".png";
}

function _stopWaitTimer() {
    debug( "stop wait timer" );
    clearInterval( waitTimer );
    waitTimer = null;
    var elem = document.getElementById( "wait" );
    elem.style.display = "none";
}


