// today's fortune from a site
function FortuneFromSite( site, fortuneclass, key ) {
    this.site = site;
    this.fortuneclass = fortuneclass;
    this.key = key;
    this.scores = new Array();
    this.messages = new Array();
    this.maxScore = 0;
    this.isLoaded = false;
    this.isLoading = false;
    this.hasScore = FortuneFromSite__hasScore;
    this.getScore = FortuneFromSite__getScore;
    this.retrieveData = FortuneFromSite__retrieveData;
    this.isAvailable  = FortuneFromSite__isAvailable;
    this.commandHandler = FortuneFromSite__commandHandler;
}

function FortuneFromSite__isAvailable() {
    if ( this.isLoaded && this.maxScore > 0 ) {
        return true;
    }
    return false;
}

function FortuneFromSite__hasScore( genre ) {
    if ( this.isAvailable() ) {
        if ( this.scores[ genre ] ) return true;
    }
    return false;
}

function FortuneFromSite__getScore( genre ) {
    if ( this.isLoaded ) {
        return this.scores[ genre ];
    } else {
        return null;
    }
}

// !retrievedata
function FortuneFromSite__retrieveData() {// items ) {
    //debug( "retrieveData" );
    if ( this.isLoaded ) return;
//     if ( items == undefined ) {
//         items = [ "general", "love", "money", "business" ];
//     }

    var output = "";
    if ( window.widget ) {
        var pycommand = "/usr/bin/python getfortune.py " + this.site + " " + this.fortuneclass + " " + this.key;
        this.isLoading = true;
        addThread( this, pycommand, null, null );
    } else {
        var command = { outputString:"MSN,aries,http://fortune.msn.co.jp/aries.armx\ngeneral,2/5,ޤ˴Ԥƿ˰ĥФ줽\nlove,2/5,åץϤäȥޥͥ굤̣ˤʤ뤫⡣\nmoney,4/5,CMΥåꤽ\nbusiness,5/5,ץեåʥʬǼʥԡǤ\n" };
        this.commandHandler( command );
    }
}

var ThreadSpool = new Array();
var ThreadSpoolPollingTimer = null;

function FortuneFromSite__removeAllThreads() {
    if ( ThreadSpoolPollingTimer != null ) {
        clearInterval( ThreadSpoolPollingTimer );
        ThreadSpoolPollingTimer = null;

        var runningThread = null;
        for ( var i = 0; i < ThreadSpool.length ;i++ ) {
            var thread = ThreadSpool[ i ];
            if ( thread.exec ) {
                thread.exec.cancel();
            }
        }
    }
    ThreadSpool = new Array();
}

function addThread( crawler, commandLine, collector, handler ) {
    var exitem = new Array();
    exitem.owner     = crawler;
    exitem.command   = commandLine;
    exitem.collector = collector;
    exitem.handler   = handler;
    ThreadSpool.push( exitem );
    if ( ThreadSpoolPollingTimer == null ) {
        ThreadSpoolPollingTimer = setInterval( __pollSiteCrawler, 100 );
    }
}

function __pollSiteCrawler() {
    //debug( "polling..." );
    if ( ThreadSpool.length == 0 ) {
        clearInterval( ThreadSpoolPollingTimer );
        ThreadSpoolPollingTimer = null;
        return;
    }
    var exitem = ThreadSpool[ 0 ];
    if ( exitem.exec ) {
        return; // executing
    }

    if ( window.widget ) {
        exitem.exec = widget.system( exitem.command, __commandHandler );
    }
}

function __commandHandler( command ) {
    //debug( "ACCEPT COMMAND" );
    var exitem = ThreadSpool.shift();//[ ThreadSpool.length - 1 ];
    debug( "complete " + exitem.command );
    exitem.owner.commandHandler( command );
    
//     debug( self );
//     self.commandHandler( command );
}

function FortuneFromSite__commandHandler( command ) {
    debug( this.site + " " + this.key );
    var outputString = command.outputString;
    if ( outputString == null || outputString == undefined ) {
        outputString = "";
    }
    var outputs = outputString.split( "\n" );
    this.isLoading = false;
    if ( outputs.length > 0 ) {
        var header = outputs[ 0 ];
        for ( var i = 1; i < outputs.length; i++ ) {
            var data  = outputs[ i ].split( "," );
//            debug( outputs[ i ] + " " + data[ 1 ] + " " + data[ 2 ] );
            if ( data.length >= 3 ) {
                var score = data[ 1 ].split( "/" );
                var point = parseInt( score[ 0 ] );
                var max   = parseInt( score[ 1 ] );
                var msg   = data[ 2 ];
                var item  = data[ 0 ];
//                debug( "'" + item + "' : " + point + " / " + max );
                if ( isNaN( point ) == false && isNaN( max ) == false) {
                    this.scores[ item ]   = point;
                    this.maxScore         = max;
                    this.messages[ item ] = msg;
                }
            }
        }
    } else {
        this.maxScore = 0;
        this.isLoaded = false;
        return;
    }

//     for ( var i = 0; i < items.length; i++ ) {
//         var item = items[ i ];
//         debug( items[ i ] + " " + this.scores[ item ] + " " + this.maxScore + " : " + this.messages[ item ] );
//     }
    this.isLoaded = true;

//         this.maxScore = 5;
//         for ( var i = 0; i < items.length; i++ ) {
//             this.scores[ items[ i ] ] = parseInt( Math.random() * this.maxScore ) + 1;
//             this.messages[ items[ i ] ] = "message-" + items[ i ];
//         }
//         this.isLoaded = true;
//     }

    repaint();
}
