#!/usr/bin/python
# -*- coding:utf-8 -*-

##def getInformation():
##    raise Exception( 'base class does not provide information' )
##    return ( 'msn', 'constellation', 'Japanese' )

##def newInstance( key ):
##    raise Exception( 'base class does not provide instances' )

class FortuneCollector:
    CONSTELLATIONS = [ "aries", "taurus", "gemini", "cancer",
                       "leo", "virgo", "libra", "scorpio",
                       "sagittarius", "capricorn", "aquarius", "pisces"]
    
    BLOOD_TYPES = [ "A", "B", "AB", "O" ]

    ## scorpius?
    def __init__( self, name = None, key = None ):
        self.__name          = name
        self.__key           = key
        self.__url           = None
        self.__scoreUnits    = 0
        self.__items         = []
        self.__scores        = {}
        self.__messages      = {}
        self.__loaded        = False
        pass

    def setURL( self, url ):
        self.__url = url
        pass

    def setName( self, name ):
        self.__name = name
        pass

    def getConstellation( self, cons ):
        self.__constellation = cons
        pass

    def getURL( self ):
        return self.__url

    def getName( self ):
        return self.__name

    #def getConstellation( self ):
    #    return self.__constellation

    def isLoaded( self ):
        return self.__loaded

    def getURL( self ):
        return self.__url

    def setScore( self, genre, score, message = None ):
        #print genre, score, message, self.__items.count( genre )
        if self.__items.count( genre ) == 0:
            self.__items.append( genre )
            pass
        self.__scores[ genre ] = score
        if message:
            self.__messages[ genre ] = message
            pass
        pass

    def setScoreUnits( self, num ):
        self.__scoreUnits = num
        pass

    def load( self ):
        import os, sys, tempfile
        if self.__loaded: return
        if self.__url:
            file_html = tempfile.mktemp()
            file_utf  = tempfile.mktemp()
            os.system( "/usr/bin/curl '%s' -s -o %s"
                       % ( self.__url, file_html ) )
            if os.path.exists( file_html ) == False:
                raise Exception( "Failed to load" )
            os.system( "/usr/bin/iconv -f %s -t utf-8 %s > %s"
                       % ( self.getEncoding(), file_html, file_utf ) )
            try:
                self.parseHTML( file_utf )
            except Exception, e:
                sys.stderr.write( repr( e ) )
                sys.stderr.write( "\n" )
                os.unlink( file_html )
                os.unlink( file_utf )
                raise e
            os.unlink( file_html )
            os.unlink( file_utf )
            self.__loaded = True
            pass
        else:
            raise Exception( "no URL set" )
        pass

    def getEncoding( self ):
        return "sjis"

    def parseHTML( self, filename ):
        raise TypeError( "not implemented in base class" )

    def getResult( self ):
        output = "%s,%s,%s\n" % ( self.__name, self.__key, self.__url )
        #print self.__items
        for item in self.__items:
            if self.__scores.has_key( item ):
                if self.__messages.has_key( item ):
                    msg = self.__messages[ item ]
                else:
                    msg = ""
                    pass
                output += "%s,%d/%d,%s\n" % ( item, self.__scores[ item ], self.__scoreUnits, msg )
                pass
            pass
        return output

    def __repr__( self ):
        return self.getResult()

    pass

