#!/usr/bin/python

def __enumerateFiles():
    import os, os.path
    pyfiles = []
    for ( path, dirs, filenames ) in os.walk( "./" ):
        for filename in filenames:
            if filename[ -3: ] == '.py':
                pyfiles.append( "%s/%s" % ( path, filename ) )
                pass
            pass
        pass
    return pyfiles

def __loadModule( filename ):
    import ihooks, os.path
    loader = ihooks.BasicModuleLoader()
    path, file = os.path.split( filename )
    name, ext = os.path.splitext( file )
    mid = loader.find_module_in_dir( name, path )
    if not mid:
        raise ImportError, name
    return loader.load_module( name, mid )

def __enumerateModules():
    modules = []
    pyfiles = __enumerateFiles()
    for filename in pyfiles:
        #print filename
        try:
            mod = __loadModule( filename )
            if dir( mod ).count( 'newInstance' ) > 0 and dir( mod ).count( 'getInformation' ) > 0:
                modules.append( mod )
                pass
            pass
        except:
            pass
        pass
    return modules
    

if __name__ == "__main__":
    # python fortunecollector.py yahoo constellation aries
    # python fortunecollector.py msn blood A
    import sys

    if len( sys.argv ) < 4: # list all modules
        modules = __enumerateModules()
        for mod in modules:
            info = mod.getInformation()
            try:
                print "%s,%s,%s" % ( info[ 0 ], info[ 1 ], info[ 2 ] )
            except:
                pass
            pass
        sys.exit()
        pass
    
    site  = sys.argv[ 1 ]
    genre = sys.argv[ 2 ]
    key   = sys.argv[ 3 ]
    if len( sys.argv ) > 4: language = sys.argv[ 4 ]
    else: language = "Japanese"
    
    modules = __enumerateModules()
    for mod in modules:
        try:
            info = mod.getInformation()
            if info[ 0 ] == site and info[ 1 ] == genre and info[ 2 ] == language:
                obj = mod.newInstance( key )
                obj.load()
                print obj.getResult()
                break
                pass
            else:
                #print site, genre, language
                #print sys.argv
                #print info
                #raise Exception, 'bad arguments'
                pass
            pass
        except Exception, e:
            raise
            #pass
        pass
    pass

